from __future__ import unicode_literals
from pcs_proxy.common import settings
from pcs_proxy.server_common import CollaboraServiceProxyLogic


##
## PCS-to-Chronophage handler
##


class CollaboraServiceProxyLogicChronophage(CollaboraServiceProxyLogic):
    service_name = "Chronophage"
    service_hostname = "chronophage.collabora.com"

    # clean_request_str in this case needn't do anything beyond return the input
    @staticmethod
    def clean_request_str(request_str):
        return request_str

    def handle_request(self, request_str):
        return None

    # Transform the URL string request_str into a dict with the keys=>values
    @staticmethod
    def parse_request_str(request_str):
        raw_str = ""
        try:
            raw_str = request_str.split("?", 1)[1]
        except IndexError:
            return {}
        fields = raw_str.split("&")
        returns = {}
        for field in fields:
            key = field.split('=', 1)[0]
            val = field.split('=', 1)[1]
            returns[key] = val
        return returns

    # For Chronophage, we need only return the path portion of the raw_str
    @staticmethod
    def build_outgoing_requests(raw_str):
        return [raw_str.path]

    # Return the URL base for API calls
    @staticmethod
    def request_URL():
        return "https://"+settings['ProxyLogicProvider'].service_hostname

    # Return the port number the proxy runs on
    @staticmethod
    def port_TCP():
        return 8000

    # All of our comms with Chronophage are done over HTTP GET
    @staticmethod
    def request_method():
        return "GET"

    # We don't need to transform results received from Chronophage, return as-is
    @staticmethod
    def result_filter(msg, rs, bh, eh):
        return msg

    # We can always count on Chronophage to react nicely to auth-related queries
    @staticmethod
    def should_retry_request_after_reauthentication(responseData):
        return False
